clear all;
rand('seed',100) %set random seed
lambda=7; %arrival rate
mu=10; %service rate
endtime=1000; %simulation length
t=0; %current time
tstep=1; %time between consecutive sample events
currcustomers=0; %current nbr of customers in system
event=zeros(1,3); %time for next arrival (pos 1),next service
                 %completion (pos 2) and next sample event
                 %(pos 3)
event(1)=exprnd(1/lambda); %next arrival
event(2)=inf; %no customer in system
event(3)=tstep; %next sample event
nbr=0; %number of measurements made
nbr2=0; %nbr of departed customers
nbrarrived=0; %nbr of cust that have arrived throughout the
              %simulations
while t<endtime
 [t,nextevent]=min(event); %move to the time of the next event and
                           %find type of nextevent
 if nextevent==1 %new arrival
   event(1)=exprnd(1/lambda)+t; %next arrival
   if currcustomers==0 %customer arrived to empty system
     event(2)=(1/mu)+t; %new customer in server
   end 
   currcustomers=currcustomers+1;
   nbrarrived=nbrarrived+1;
   arrivedtime(nbrarrived)=t; %the new customer arrived at time t
 elseif nextevent==2 %service completion
     currcustomers=currcustomers-1;
     if currcustomers>0
       event(2)=(1/mu)+t; %new customer in server
     else
       event(2)=inf; %empty system;
     end
     timeinsystem=t-arrivedtime(nbrarrived-currcustomers);
     nbr2=nbr2+1;
     T(nbr2)=timeinsystem; %vector with the job response times 
 else %sample event
   nbr=nbr+1;
   N(nbr)=currcustomers; %vector with nbr of customers in system at the sample events
   event(3)=event(3)+exp(1/tstep); %set time for new sample event
 end
end

















